=== debian/changelog ===
supertuxkart (0.9.3-1) unstable; urgency=medium

  * New upstream release.
    - Fix segfault in MusicInformation::isPlaying. (Closes: #873670)
    - Fix credits for Boom-boom-boom song. (Closes: #848001)
    - Remove obsolete patches: replace-fonts-ubuntu-with-cantarell.patch,
      update_boom_boom_boom_license.patch, fix_angelscript_ftbfs.patch,
      irrlicht/link-against-needed-libs.diff.
    - Refresh remaining patches.
  * Add new font dependencies for supertuxkart-data: fonts-freefont-ttf,
    fonts-noto-hinted,
  * Bump Standards version to 4.1.2.
    - Change priority of debug package from extra to optional.

 -- Vincent Cheng <vcheng@debian.org>  Sun, 17 Dec 2017 20:16:38 -0800
