=== debian/watch ===
version=3
opts=dversionmangle=s/\+dfsg\d+$//g \
http://sf.net/supertuxkart/supertuxkart-([\d\.]*)-src\.(?:tar\.(?:gz|bz2|xz))
